
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title ADD (register, Thumb)

@encoding(t1) {

    @half 0 0 0 1 1 0 0 Rm(3) Rn(3) Rd(3)

    @syntax <Rd> <Rn> <Rm>

    @conv {

        Rd = Register(Rd)
        Rn = Register(Rn)
        Rm = Register(Rm)

    }

}

@encoding(t2) {

    @half 0 1 0 0 0 1 0 0 DN(1) Rm(4) Rdn(3)

    @syntax <Rdn> <Rm>

    @conv {

        Rdn = Register(DN:Rdn)
        Rm = Register(Rm)

    }

    @rules {

        //if (DN:Rdn) == '1101' || Rm == '1101' then SEE ADD (SP plus register);
        //if n == 15 && m == 15 then UNPREDICTABLE;
        //if d == 15 && InITBlock() && !LastInITBlock() then UNPREDICTABLE;

    }

}

@encoding(T3) {

    @word 1 1 1 0 1 0 1 1 0 0 0 S(1) Rn(4) 0 imm3(3) Rd(4) imm2(2) type(2) Rm(4)

    @syntax {S} ".W" <Rd> <Rn> <Rm> <?shift>

    @conv {

        S = SetFlags(S)
        Rd = Register(Rd)
        Rn = Register(Rn)
        Rm = Register(Rm)
        shift = DecodeImmShift(type, imm3:imm2)

    }

    @rules {

        //if Rd == '1111' && S == '1' then SEE CMN (register);
        //if Rn == '1101' then SEE ADD (SP plus register);
        //if d == 13 || (d == 15 && S == '0') || n == 15 || m IN {13,15} then UNPREDICTABLE;


    }

}
