
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title POP (ARM)

@encoding(A1) {

    @word cond(4) 1 0 0 0 1 0 1 1 1 1 0 1 register_list(16)

    @syntax {c} <registers>

    @conv {

        c = Condition(cond)
        registers = RegistersList(register_list)

    }

    @rules {

        //if BitCount(register_list) < 2 then SEE LDM / LDMIA / LDMFD;
        //if registers<13> == '1' && ArchVersion() >= 7 then UNPREDICTABLE;
        if (register_list & 0x8000) ; chk_call SetInsFlag(AIF_RETURN_POINT)

    }

}

@encoding(A2) {

    @word cond(4) 0 1 0 0 1 0 0 1 1 1 0 1 Rt(4) 0 0 0 0 0 0 0 0 0 1 0 0

    @syntax {c} <registers>

    @conv {

        c = Condition(cond)
        Rgt = Register(Rt)
        registers = ListFromRegister(Rgt)

    }

    @rules {

        //if t == 13 then UNPREDICTABLE;
        if (Rt == '1111') ; chk_call SetInsFlag(AIF_RETURN_POINT)

    }

}
