
/* Chrysalide - Outil d'analyse de fichiers binaires
 * keyword.h - prototypes pour les insertions de mots clefs de haut niveau
 *
 * Copyright (C) 2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_INSTR_KEYWORD_H
#define _DECOMP_INSTR_KEYWORD_H


#include <glib-object.h>


#include "../instruction.h"



#define G_TYPE_KEYWORD_INSTRUCTION               g_keyword_instruction_get_type()
#define G_KEYWORD_INSTRUCTION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_keyword_instruction_get_type(), GKeywordInstruction))
#define G_IS_KEYWORD_INSTRUCTION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_keyword_instruction_get_type()))
#define G_KEYWORD_INSTRUCTION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_KEYWORD_INSTRUCTION, GKeywordInstructionClass))
#define G_IS_KEYWORD_INSTRUCTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_KEYWORD_INSTRUCTION))
#define G_KEYWORD_INSTRUCTION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_KEYWORD_INSTRUCTION, GKeywordInstructionClass))



/* Type de mots clefs pris en charge */
typedef enum _DecompiledKeyWord
{
    DKW_BREAK,                              /* 'break'                     */
    DKW_CONTINUE,                           /* 'continue'                  */

} DecompiledKeyWord;


/* Définition d'un mot clef de haut niveau (instance) */
typedef struct _GKeywordInstruction GKeywordInstruction;

/* Définition d'un mot clef de haut niveau (classe) */
typedef struct _GKeywordInstructionClass GKeywordInstructionClass;


/* Indique le type défini pour un mot clef de haut niveau. */
GType g_keyword_instruction_get_type(void);

/* Crée un mot clef de haut niveau. */
GDecInstruction *g_keyword_instruction_new(DecompiledKeyWord);



#endif  /* _DECOMP_INSTR_KEYWORD_H */
